## libntruprime 0~20241021

=== crypto_core/inv3sntrup1013/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 1013 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_core/inv3sntrup1277/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 1277 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_core/inv3sntrup653/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 653 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_core/inv3sntrup761/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 761 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_core/inv3sntrup857/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 857 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_core/inv3sntrup953/avx/Makefile ===
r3_recip.c: r3_recipgen.py
	./r3_recipgen.py 953 > r3_recip.c
	touch -r r3_recipgen.py r3_recip.c

=== crypto_decode/1013x2393/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 1013 2393 2393 3588 True > decode.c
	touch -r decodegen.py decode.c

=== crypto_decode/1013x7177/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 1013 7177 > decode.c
	touch -r decodegen.py decode.c

=== crypto_decode/1277x2627/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 1277 2627 2627 3939 True > decode.c
	touch -r decodegen.py decode.c

=== crypto_decode/1277x7879/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 1277 7879 > decode.c
	touch -r decodegen.py decode.c

=== crypto_decode/653x1541/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 653 1541 1541 2310 True > decode.c
	touch -r decodegen.py decode.c

=== crypto_decode/653x4621/avx/Makefile ===
decode.c: decodegen.py
	./decodegen.py 653 4621 > decode.c
	touch -r decodegen.py decode.c

=== debian/changelog ===
libntruprime (0~20241021-5) unstable; urgency=medium

  * debci: Improve valgrind KEM testing, disable on riscv64 for now.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 04 Nov 2025 12:37:30 +0100

libntruprime (0~20241021-4) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/watch: rewrite to version 5
  * d/salsa-ci.yml: add SALSA_CI_AUTOPKGTEST_ALLOWED_EXIT_STATUS: '0'
  * d/control: remove Rules-Requires-Root: no

  [ Simon Josefsson ]
  * Add lrc.excludes.
  * Re-generate man-pages.
  * Tighten Salsa CI.
  * Add lintian overrides.
  * Bump debian/* copyright years.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 02 Nov 2025 21:27:47 +0100

libntruprime (0~20241021-3) unstable; urgency=medium

  * Standards-Version: 4.7.2.
  * Fix Vcs-* URLs.
  * Change maintainer to pkg-security.
  * Run wrap-and-sort -satbk.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 16 Aug 2025 13:07:20 +0200

libntruprime (0~20241021-2) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/t/0001-m68k-skip-checkinsns-test.patch add, fix build on m68k
  * d/control: use valgrind-if-available instead of valgrind in Recommends
  * d/t/control: replace valgrind test 'valgrind-test-kem' with
    'valgrind-test-kem-sntrup1277', the previous test tested all sntrup*
    algorithms, but failed on s390x due to debci timeout, now only sntrup1277
    is tested

 -- Simon Josefsson <simon@josefsson.org>  Fri, 25 Oct 2024 12:11:57 +0200

libntruprime (0~20241021-1) unstable; urgency=medium

  [ Jan Mojžíš ]
  * New upstream version 0~20241021
  * d/control: add Jan Mojžíš to uploaders
  * d/rules: disable hardening-stackclash on armhf
  * d/t/testntruprime-{shared,static}: add
  * d/t/control: add simple valgrind test 'valgrind-test-kem'
  * d/control: add Build-Depends: python3-capstone
  * d/p/gdwarf4.patch: remove, additional debug symbols are no longer needed

 -- Simon Josefsson <simon@josefsson.org>  Wed, 23 Oct 2024 23:04:13 +0200

libntruprime (0~20241008-2) unstable; urgency=medium

  * control: Spell out ntruprime binaries, for search.
  * d/t/control: run mceliece-fulltest only on amd64
  * Build with gdwarf-4 (suggested by upstream).

 -- Simon Josefsson <simon@josefsson.org>  Mon, 14 Oct 2024 15:08:50 +0200

libntruprime (0~20241008-1) unstable; urgency=medium

  * New upstream version 0~20241008
  * Run wrap-and-sort -satbk.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 13 Oct 2024 18:17:28 +0200

libntruprime (0~20240825-1) unstable; urgency=medium

  * Initial release. (Closes: #1079669)

 -- Simon Josefsson <simon@josefsson.org>  Mon, 26 Aug 2024 06:54:47 +0200

=== debian/control ===
Source: libntruprime
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
 Jan Mojžíš <jan.mojzis@gmail.com>,
Priority: optional
Standards-Version: 4.7.2
Section: libs
Homepage: https://libntruprime.cr.yp.to/
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 libcpucycles-dev,
 librandombytes-dev,
 pandoc [!m68k !sh4 !x32] <!nodoc>,
 python3,
 python3-capstone,
 valgrind-if-available,
Vcs-Git: https://salsa.debian.org/debian/libntruprime.git
Vcs-Browser: https://salsa.debian.org/debian/libntruprime

Package: libntruprime-dev
Section: libdevel
Architecture: any
Depends:
 libntruprime1 (= ${binary:Version}),
 ${misc:Depends},
Description: microlibrary for Streamlined NTRU Prime - development files
 libntruprime is an implementation of the Streamlined NTRU Prime
 cryptosystem as a microlibrary.
 .
 Development files.

Package: libntruprime1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: microlibrary for Streamlined NTRU Prime - shared library
 libntruprime is an implementation of the Streamlined NTRU Prime
 cryptosystem as a microlibrary.
 .
 Streamlined NTRU Prime (sntrup) is a lattice-based cryptosystem with
 the following features:
 .
   - Stability: Almost all details of sntrup match a May 2016
   publication. The only exceptions are small changes to encoding and
   hashing published in April 2019.
 .
   - Patent-freeness: April 2019 predates almost all post-quantum
   patents. Analyses of various lattice patents filed before April
   2019 indicate no problems for sntrup.
 .
   - Deployment: The popular OpenSSH tool switched to sntrup761 by
   default in April 2022, following initial integration of sntrup into
   TinySSH.
 .
   - Affordability: Keys and ciphertexts are about 1KB for sntrup761,
   and computations are fast.
 .
   - Careful design: Subject to the requirement of being a small
   lattice-based cryptosystem, sntrup is systematically designed to
   eliminate unnecessary complications in security review. It
   eliminates decryption failures, for example, and eliminates
   cyclotomics. The cryptosystem has never needed a security patch.
 .
   - Risk management: A much higher sntrup1277 security level is fully
   supported, and is recommended whenever 2KB keys and ciphertexts are
   affordable, to reduce risks from improvements in lattice attacks.
 .
 - Flexibility: The sntrup design allows a full spectrum of tradeoffs
   between size and security level, so applications with intermediate
   size limits aren't forced into much lower security levels. Six
   different sizes have been selected for support.
 .
 libntruprime has a very simple stateless API based on the SUPERCOP
 API, with wire-format inputs and outputs, providing functions that
 directly match the KEM operations provided by the sntrup
 specification, such as functions
 .
 sntrup1277_keypair
 sntrup1277_enc
 sntrup1277_dec
 .
 for the sntrup1277 KEM.
 .
 Internally, libntruprime includes implementations designed to work
 portably across CPUs, and implementations designed for higher
 performance on Intel/AMD CPUs with AVX2 instructions. libntruprime
 includes automatic run-time selection of implementations.
 .
 libntruprime is intended to be called by larger multi-function
 libraries (such as traditional cryptographic libraries), including
 libraries in other languages via FFI. The idea is that libntruprime
 takes responsibility for the details of sntrup computation, including
 optimization, timing-attack protection, and (in ongoing work)
 verification, freeing up the calling libraries to concentrate on
 application-specific needs such as protocol integration. Applications
 can also call libntruprime directly.
 .
 Shared library.

Package: ntruprime
Section: devel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 valgrind-if-available,
 ${python3:Depends},
Description: microlibrary for Streamlined NTRU Prime - command line tools
 libntruprime is an implementation of the Streamlined NTRU Prime
 cryptosystem as a microlibrary.
 .
 The command-line interface for libntruprime provides the following
 command-line tools:
 .
 sntrup653-keypair sntrup761-keypair sntrup857-keypair sntrup953-keypair
                   sntrup1013-keypair sntrup1277-keypair
 sntrup653-enc sntrup761-enc sntrup857-enc sntrup953-enc
               sntrup1013-enc sntrup1277-enc
 sntrup653-dec sntrup761-dec sntrup857-dec sntrup953-dec
               sntrup1013-dec sntrup1277-dec
 ntruprime-fulltest
 ntruprime-speed
 ntruprime-test
 .
 Each tool exits 0 on success, nonzero on failure.
 .
 These tools allow libntruprime to be easily used from shell
 scripts. Other languages can also use libntruprime via these tools,
 but languages typically have good support for FFI and can use the C
 interface directly.
 .
 Key generation (for, e.g., sntrup1277):
 sntrup1277-keypair 5>publickey 9>secretkey
 .
 Encapsulation (for, e.g., sntrup1277):
 sntrup1277-enc >ciphertext 7>sessionkey 4<publickey
 .
 Decapsulation (for, e.g., sntrup1277):
 sntrup1277-dec 7>sessionkey <ciphertext 8<secretkey
 .
 The ntruprime-speed, ntruprime-test and ntruprime-fulltest tools can be used
 for benchmarking and internal self testing.  Python and Valgrind is only
 needed for the ntruprime-fulltest tool, the other tools are written in C.
 .
 Command line tools.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack

# Disable hardening-stackclash on armhf.
# On armhf, valgrind test dies with a SIGSEGV when
# built with either -fstack-clash-protection or -fstack-check.
ifeq ($(DEB_TARGET_ARCH), armhf)
export DEB_BUILD_MAINT_OPTIONS = hardening=hardening=+all,-stackclash
endif

# crossbuild
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
include /usr/share/dpkg/buildtools.mk
endif

%:
	dh $@ --with python3

# The debian/compiler directory contains gcc and clang wrappers.
# It adds Debian specifific options distributed in
# $CC, $CFLAGS, $CPPFLAGS and $LDFLAGS
export PATH := $(shell pwd)/debian/compiler:$(PATH)

# Detects the correct ABINAME from the DEB_BUILD_ARCH
# instead of run-time detection. Fixes FTBR.
ABINAME=$(DEB_BUILD_ARCH)
ifeq ($(ABINAME), x32)
ABINAME=amd64
endif

COMMAND_VALGRIND = $(shell command -v valgrind)

ifeq ($(filter /usr/bin/valgrind,$(COMMAND_VALGRIND)),)
DISABLE_VALGRIND += --no-valgrind
endif

override_dh_auto_configure:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	head -v $(shell find . -name sntrup.1)
	(! command -v pandoc) || autogen/man
	head -v $(shell find . -name sntrup.1)
endif
	./configure --host=$(ABINAME) --prefix=/usr $(DISABLE_VALGRIND)

override_dh_auto_clean:
	rm -rf ./build

# disable auto installation
override_dh_auto_install:

=== debian/tests/control ===
Test-Command: ntruprime-speed
Features:
 test-name=ntruprime-speed,
Depends:
 ntruprime,

Test-Command: ntruprime-test
Features:
 test-name=ntruprime-test,
Depends:
 ntruprime,

Test-Command: env valgrind_multiplier=1 valgrind -q --error-exitcode=99 ntruprime-test kem
Architecture: !loong64 !riscv64
Features:
 test-name=valgrind-test-kem,
Depends:
 ntruprime,
 valgrind,

Test-Command: ntruprime-fulltest
Architecture: amd64
Features:
 test-name=ntruprime-fulltest,
Depends:
 ntruprime,
 python3,
 @recommends@,

Tests:
 testntruprime-static,
Depends:
 dpkg-dev,
 build-essential,
 libntruprime-dev,
 librandombytes-dev,

Tests:
 testntruprime-shared,
Depends:
 dpkg-dev,
 build-essential,
 libntruprime-dev,
 libntruprime1,
 librandombytes-dev,

=== debian/watch ===
Version: 5
Source: https://libntruprime.cr.yp.to/download.html
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
Uversion-Mangle: s/^/0~/
